const int NUMROW = 54, NUMCOLUMN = 4;
const char* plugindesc[NUMROW][NUMCOLUMN] = {
{ "quadratic", "z<sup>2</sup>+c", "Quadratic family", "" },
{ "quadfix", "az(1+z)", "Quadratic family with fixed point 0", "" },
{ "quadray", "z<sup>2</sup>+c", "Quadratic family", "with external rays" },
{ "quadrayper2", "z<sup>2</sup>+c", "Quadratic family", "with period 2 external rays" },
{ "quadrayper3", "z<sup>2</sup>+c", "Quadratic family", "with period 3 external rays" },
{ "quadrayper4", "z<sup>2</sup>+c", "Quadratic family", "with period 4 external rays" },
{ "tricorn", "<span style=\"text-decoration: overline\">z</span><sup>2</sup>+c", "Tricorn", "" },
{ "unicrit", "z<sup>d</sup>+c", "Unicritical family", "" },
{ "unicrit-green", "z<sup>d</sup>+c", "Unicritical family", "by Milnor's hyperbolic metric algorithm (using Green's function)" },
{ "cubicnewton", "Newton map for f(z)=z(z-1)(z-d)", "Cubic Newton map", "" },
{ "rat2per2", "1/4*c/(z<sup>2</sup>-z)", "Quadratic rational map with period 2 critical point (0&rarr;&infin;&rarr;0)", "" },
{ "rat2per3", "1/(cz<sup>2</sup>-(c+1)z+1)", "Quadratic rational map with period 3 critical point (0&rarr;1&rarr;&infin;&rarr;0)", "" },
{ "henonunstable", "(x,y)&rarr;(by+x<sup>2</sup>+c,x)", "unstable slice of K+ for complex Henon map at saddle fixed point", "" },
{ "doublestandard", "ax<sup>2</sup>exp(b(x-1/x))", "Double standard map", "" },
{ "cubicreal", "z<sup>3</sup>-3a<sup>2</sup>z+b", "Real cubic polynomials ", "in (A, B)-plane (A=a<sup>2</sup>, B=b<sup>2</sup>)" },
{ "cubicsuper", "z<sup>3</sup>-az<sup>2</sup>", "Cubic polynomials with critical fixed point", "" },
{ "cubicsuperray", "z<sup>3</sup>-az<sup>2</sup>", "Cubic polynomials with critical fixed point", "with external rays" },
{ "cubicsuperper2", "az<sup>3</sup>-(a+1)z<sup>2</sup>+1", "Cubic polynomials with period 2 critical point", "" },
{ "cubicsuperper2ray", "a<sup>2</sup>z<sup>3</sup>-(a<sup>2</sup>+1)z<sup>2</sup>+1", "Cubic polynomials with period 2 critical point", "with external rays" },
{ "cubicsuperper3", "az<sup>3</sup>+bz<sup>2</sup>+1", "Cubic polynomials with period 3 critical point", "a=-(c<sup>3</sup>-c<sup>2</sup>+1)/(c<sup>3</sup>-c<sup>2</sup>), b=(c<sup>4</sup>-c<sup>3</sup>+1)/(c<sup>3</sup>-c<sup>2</sup>)" },
{ "cubicsuperper3ray", "az<sup>3</sup>+bz<sup>2</sup>+1", "Cubic polynomials with period 3 critical point", "with external rays, a=-(c<sup>3</sup>-c<sup>2</sup>+1)/(c<sup>3</sup>-c<sup>2</sup>), b=(c<sup>4</sup>-c<sup>3</sup>+1)/(c<sup>3</sup>-c<sup>2</sup>)" },
{ "cubicsuperper3torusray", "az<sup>3</sup>+bz<sup>2</sup>+1", "Cubic polynomials with period 3 critical point", "with external rays, parametrized using Weierstrass P-function" },
{ "cauliflower", "z<sup>2</sup>+1/4", "Cauliflower", "" },
{ "nearcaliflower", "az(1+z) (a=cos(2&pi;&alpha;)+isin(2&pi;&alpha;))", "Quadratic family (near cauliflower)", "colored in Fatou coordinate" },
{ "quadfixexp", "az(1+z) (a=exp(2&pi;ic))", "Quadratic family with fixed point 0", "parameter a is in log coordinate" },
{ "typeE2", "cz(1+z/2)<sup>2</sup>", "Type E2 map by Branner-Fagella", "" },
{ "typeE3", "cz(1+z/3)<sup>3</sup>", "Type E3 map by Branner-Fagella", "" },
{ "cubic-a2-ray", "z<sup>3</sup>-3a<sup>2</sup>z+b", "Cubic polynomials with external rays", "a-plane&rarr;b-plane&rarr;z-plane" },
{ "cubic-b-ray", "z<sup>3</sup>-3a<sup>2</sup>z+b", "Cubic polynomials with external rays", "b-plane&rarr;a-plane&rarr;z-plane" },
{ "cubic-b", "z<sup>3</sup>-3a<sup>2</sup>z+b", "Cubic polynomials", "b-plane&rarr;a-plane&rarr;z-plane" },
{ "cubicato-a", "z<sup>3</sup>-3a<sup>2</sup>z+2a<sup>3</sup>-a", "Cubic polynomials with critical relation a&rarr;-a", "" },
{ "cubicato-arayper3", "z<sup>3</sup>-3a<sup>2</sup>z+2a<sup>3</sup>-a", "Cubic polynomials with critical relation a&rarr;-a", "with period 3 external rays" },
{ "cubicfix1-2", "bz-az<sup>2</sup>+z<sup>3</sup>", "Cubic polynomial with fixed point 0", "a-plane&rarr;b-plane&rarr;z-plane" },
{ "cubicfix1", "bz-az<sup>2</sup>+z<sup>3</sup>", "Cubic polynomial with fixed point 0", "b-plane&rarr;a-plane&rarr;z-plane" },
{ "cubicfixray", "bz-az<sup>2</sup>+z<sup>3</sup>", "Cubic polynomial with fixed point 0", "with external rays" },
{ "biquad1", "(z<sup>2</sup>+a)<sup>2</sup>+b", "Biquadratic family", "" },
{ "biquadfix1", "bz(1+z)(1+az(1+z))", "Biquadratic family with fixed point", "" },
{ "biquadfix1alt", "bz(1+z)(1+az(1+z))", "Biquadratic family with fixed point", "different normalization and parametrization" },
{ "biquadreal", "(z<sup>2</sup>+a)<sup>2</sup>+b", "Real biquadratic family", "" },
{ "biquadrealray", "(z<sup>2</sup>+a)<sup>2</sup>+b", "Real biquadratic family", "with external rays" },
{ "cubiclavaurs", "z+az<sup>2</sup>+z<sup>3</sup>", "Parabolic cubic polynomials with Lavaurs map", "" },
{ "cubiclavaurs2", "z+az<sup>2</sup>+z<sup>3</sup>", "Parabolic cubic polynomials with Lavaurs map", "with better approximation of Lavaurs map" },
{ "fix-twocrit-ray", "(z-a)<sup>d-1</sup>((d-1)z-db-a)+(-a)<sup>d-1</sup>(db-a)", "Polynomials with fixed point 0 and two critical points with multiplicity 1 and d-1", "with external rays" },
{ "fix-twocrit", "(z-a)<sup>d-1</sup>((d-1)z-db-a)+(-a)<sup>d-1</sup>(db-a)", "Polynomials with fixed point 0 and two critical points with multiplicity 1 and d-1", "" },
{ "lavaursray", "z(1+z), &Phi;<sup>-1</sup>(&Phi(z)+a)", "Parabolic quadratic polynomial with Lavaurs map", "with external rays" },
{ "lavaursray2", "z(1+z), &Phi;<sup>-1</sup>(&Phi(z)+a)", "Parabolic quadratic polynomial with Lavaurs map", "with external rays & better approximation of Lavaurs map" },
{ "quad-nearparab", "z(z-2+a)/(az-1)", "Quadratic family ", "coordinate changed to w-coordinate s.t. z=&infin;&rarr;w=1, fixed points: w= 0, &infin;" },
{ "quad-prefatou", "az(1+z) (a=exp(2&pi;i&alpha;))", "Quadratic family in pre-Fatou coordinate", "" },
{ "quar-fix-p3", "-z-az<sup>3</sup>+bz<sup>4</sup>", "Degree 4 polynomials (0: parabolic fixed point with period 2 petals, 1: critical point)", "" },
{ "quar-fix-super-green", "(z-1)<sup>2</sup>(bz<sup>2</sup>+(a-2)z-1)+1", "Degree 4 polynomials (0: fixed point, 1: critical fixed point) by Green's function algorithm", "" },
{ "quar-fix-super", "(z-1)<sup>2</sup>(bz<sup>2</sup>+(a-2)z-1)+1", "Degree 4 polynomials (0: fixed point, 1: critical fixed point)", "" },
{ "quar-sa-parab", "z+z(z-1)<sup>2</sup>(az-1)", "Degree 4 polynomials (0: parabolic fixed point, c: critical fixed point) ", "a=1/2*(-4+3c)/(-3c+1+2c<sup>2</sup>" },
{ "realimplosion3", "-z<sup>3</sup>+az<sup>2</sup>+z+b", "Parabolic implosion for real cubic polynomials", "" },
{ "realimplosion3ray", "-z<sup>3</sup>+az<sup>2</sup>+z+b", "Parabolic implosion for real cubic polynomials", "with external rays" }
};
